#include<stdio.h>
#define ROWS 3
#define COLS 4

/*
 * Scrivere una funzione che data una matrice di interi ritorna
 * un PUNTATORE all'elemento minimo della matrice stessa
 *
 *
 */

/*
 * Versione errata della funzione
 * In questa funzione si fa puntare 'min' all'elemento minimo
 * Essendo in C i parametri passati per valore (creati ex novo 
 * all'interno della funzione), all'uscita dalla funzione 'min'
 * tornera' a puntare al valore precedente ma questo valore sara'
 * cambiato al valore del primo elemento della matrice
 *
 */

void minPunt (int *matrice, int righe, int colonne,int *min){
   int i=0,j=0;
   *min=*matrice;  //!!!!!!!!!!!!!!!!!
   for (i=0; i < righe; i++) {
      for (j=0; j < colonne; j++) {
	 if( *min > *(matrice+(i*colonne)+j) ) {
	    min = (matrice+(i*colonne)+j);
	 }
      }
      
   }
}


/*
 * Versione giusta
 * In questo caso per passare l'informazione si usa il tipo di ritorno
 * della funzione stessa
 *
 */
int* minPunt2 (int *matrice, int righe, int colonne){
   int i=0,j=0;
   int *min=matrice;
   for (i=0; i < righe; i++) {
      for (j=0; j < colonne; j++) {
	 if( *min > *(matrice+(i*colonne)+j) ) {
	    min = (matrice+(i*colonne)+j);
	 }
      }
      
   }
   /*
    * Viene ritornato il puntatore al valore minimo
    *
    */
   return min;  
};


void readMatrice(int *matrice, int righe, int colonne) {
   int numelements = righe*colonne;
   int i;
   int *p = matrice;
   for (i=0; i < numelements; i++) {
      scanf("%d", p++);
   }
   //  return matrice;
}

void printMatrice(int *matrice, int righe, int colonne) {
   int i, j;
   for (i=0; i < righe; i++) {
      for (j=0; j < colonne; j++) {
	 printf("%d ", *(matrice+(i*colonne)+j));
      }
      printf("\n");
   }
}


main(){
   int mat[ROWS][COLS];
   
   printf("Inserisci i valori della matrice %d x %d...\n",ROWS,COLS);
   readMatrice(*mat, ROWS, COLS);
   printf("\n");
   printMatrice(*mat, ROWS, COLS);
   printf("\n");    
   
   /*
    * Esempio di utilizzo della funzione sbagliata
    *
    */
   
   int j=20;
   
   /* minMat punta a j */
   int *minMat = &j;
   
   /* minMat continua a puntare a j */
   minPunt(*mat, ROWS, COLS, minMat);
   printf("minMat=%d j=%d\n\n",*minMat, j);  
   
   int j2=0;
   
   /* minMat punta a j */
   int *minMat2 = &j2;
   
   /* In questo caso minMat punta correttamente all'elemento minimo */ 
   minMat2 = minPunt2(*mat,ROWS, COLS);
   printf("minMat2=%d j2=%d\n\n",*minMat2, j2); 
   
   /* Modifico il valore minimo della matrice */
   *minMat2 = 100;
   printMatrice(*mat, ROWS, COLS);
   
}
